;/* error codes */
BE_ERR_SUCCESSFUL					= 0x00000000
BE_ERR_INVALID_FORMAT				= 0x00000001
BE_ERR_INVALID_FORMAT_PARAMETERS	= 0x00000002
BE_ERR_NO_MORE_HANDLES				= 0x00000003
BE_ERR_INVALID_HANDLE				= 0x00000004
BE_ERR_BUFFER_TOO_SMALL				= 0x00000005

;VBRMETHOD's
VBR_METHOD_NONE			= -1
VBR_METHOD_DEFAULT		=  0
VBR_METHOD_OLD			=  1
VBR_METHOD_NEW			=  2
VBR_METHOD_MTRH			=  3
VBR_METHOD_ABR			=  4

;/* other constants */

BE_MAX_HOMEPAGE			=	128

;/* format specific variables */

BE_MP3_MODE_STEREO		=	0
BE_MP3_MODE_JSTEREO		=	1
BE_MP3_MODE_DUALCHANNEL	=	2
BE_MP3_MODE_MONO		=	3

MPEG1					=	1
MPEG2					=	0
BE_MAX_HOMEPAGE			=	128
BE_CONFIG_LAME			=	256
BE_MP3_MODE_JSTEREO		=	1


;LAME_QUALITY_PRESET
;	// QUALITY PRESETS
	LQP_NORMAL_QUALITY		= 0
	LQP_LOW_QUALITY			= 1
	LQP_HIGH_QUALITY		= 2
	LQP_VOICE_QUALITY		= 3
	LQP_R3MIX				= 4
	LQP_VERYHIGH_QUALITY	= 5
	LQP_STANDARD			= 6
	LQP_FAST_STANDARD		= 7
	LQP_EXTREME				= 8
	LQP_FAST_EXTREME		= 9
	LQP_INSANE				= 10
	LQP_ABR					= 11
	LQP_CBR					= 12
	LQP_MEDIUM				= 13
	LQP_FAST_MEDIUM			= 14

;	// NEW PRESET VALUES
	LQP_PHONE	=1000
	LQP_SW		=2000
	LQP_AM		=3000
	LQP_FM		=4000
	LQP_VOICE	=5000
	LQP_RADIO	=6000
	LQP_TAPE	=7000
	LQP_HIFI	=8000
	LQP_CD		=9000
	LQP_STUDIO	=10000


CURRENT_STRUCT_VERSION	=	1
CURRENT_STRUCT_SIZE		=	sizeof.BE_CONFIG	;// is currently 331 bytes

struct	be_version
;	// BladeEnc DLL Version number
	byDLLMajorVersion	db 0
	byDLLMinorVersion	db 0

;	// BladeEnc Engine Version Number
	byMajorVersion		db 0
	byMinorVersion		db 0

;	// DLL Release date
	byDay				db 0
	byMonth				db 0
	wYear				dw 0

;	// BladeEnc	Homepage URL
	zHomepage			db 129 dup(0)

	byAlphaLevel		db 0
	byBetaLevel			db 0
	byMMXEnabled		db 0

	btReserved			db 125 dup(0)
ends

struct	mp3_struct
	dwSampleRate	dd 0;			// 48000, 44100 and 32000 allowed
	byMode			db 0;			// BE_MP3_MODE_STEREO, BE_MP3_MODE_DUALCHANNEL, BE_MP3_MODE_MONO
	wBitrate		dw 0;			// 32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256 and 320 allowed
	bPrivate		dd 0;		
	bCRC			dd 0;
	bCopyright		dd 0;
	bOriginal		dd 0;
ends

struct	lvh1_struct
	dwStructVersion	dd 0;	
	dwStructSize	dd 0;

;			// BASIC ENCODER SETTINGS
	dwSampleRate	dd 0;			// SAMPLERATE OF INPUT FILE
	dwReSampleRate	dd 0;			// DOWNSAMPLERATE, 0=ENCODER DECIDES  
	nMode			dd 0;			// BE_MP3_MODE_STEREO, BE_MP3_MODE_DUALCHANNEL, BE_MP3_MODE_MONO
	dwBitrate		dd 0;			// CBR bitrate, VBR min bitrate
	dwMaxBitrate	dd 0;			// CBR ignored, VBR Max bitrate
	nPreset			dd 0;			// Quality preset, use one of the settings of the LAME_QUALITY_PRESET enum
	dwMpegVersion	dd 0;			// FUTURE USE, MPEG-1 OR MPEG-2
	dwPsyModel		dd 0;			// FUTURE USE, SET TO 0
	dwEmphasis		dd 0;			// FUTURE USE, SET TO 0

;			// BIT STREAM SETTINGS
	bPrivate		dd 0;			// Set Private Bit (TRUE/FALSE)
	bCRC			dd 0;			// Insert CRC (TRUE/FALSE)
	bCopyright		dd 0;			// Set Copyright Bit (TRUE/FALSE)
	bOriginal		dd 0;			// Set Original Bit (TRUE/FALSE)

;			// VBR STUFF
	bWriteVBRHeader	dd 0;			// WRITE XING VBR HEADER (TRUE/FALSE)
	bEnableVBR		dd 0;			// USE VBR ENCODING (TRUE/FALSE)
	nVBRQuality		dd 0;			// VBR QUALITY 0..9
	dwVbrAbr_bps	dd 0;			// Use ABR in stead of nVBRQuality
	nVbrMethod		dd 0;
	bNoRes			dd 0;			// Disable Bit resorvoir (TRUE/FALSE)

;			// MISC SETTINGS
	bStrictIso		dd 0;			// Use strict ISO encoding rules (TRUE/FALSE)
	nQuality		dw 0;			// Quality Setting, HIGH BYTE should be NOT LOW byte, otherwhise quality=5

;			// FUTURE USE, SET TO 0, align strucutre to 331 bytes
	btReserved		db 237 dup(0);	//[255-4*sizeof(DWORD) - sizeof( WORD )];
ends

struct	aac_struct
	dwSampleRate		dd 0;
	byMode				db 0;
	wBitrate			dw 0;
	byEncodingMethod	db 0;
ends

struct	format_struct
	union
		mp3		mp3_struct
		LHV1	lvh1_struct
		aac		aac_struct
	ends
ends

struct	BE_CONFIG
	dwConfig	dd	?;				// BE_CONFIG_XXXXX
;									// Currently only BE_CONFIG_MP3 is supported
	format	format_struct
ends		
